﻿using UnityEngine;
using System.Collections;

public class RocketBehaviour : BaseBulletBehaviour {
	const int ROCK_COUNT = 6;
	const float EXPLOSION_AMOUNT = -0.5f;
	const int HIT_FORCE = 25;
	public GameObject rockPrefab;
	public LayerMask playerMask;

	// Use this for initialization
	void Start () {
		rigidbody.AddRelativeForce(10000.0f,0,0);
	}

	void OnCollisionEnter(Collision other) {
		// TODO: terrain destruction
		Vector3 pos = other.contacts[0].point;
		int x =  TerrainBehaviour.TranslateX(pos.x);
		int y =  TerrainBehaviour.TranslateY(pos.z);

		float totalAmount = TerrainBehaviour.instance.ModifyTerrain(y,x,
			TerrainBehaviour.instance.bigExplosion,EXPLOSION_AMOUNT);

		for (int i=0;i<ROCK_COUNT;++i)
		{
			GameObject obj = (GameObject)GameObject.Instantiate(rockPrefab);
			obj.GetComponent<RockBehaviour>().amount = totalAmount / ROCK_COUNT;

			pos = new Vector3(
				pos.x + Random.Range (-1.0f,1.0f) * 10.0f,0,
				pos.z + Random.Range (-1.0f,1.0f) * 10.0f);
			obj.transform.position = pos;

		}

		RaycastHit[] hitInfos = Physics.SphereCastAll(pos,35.0f,Vector3.forward,1.0f,playerMask);
		foreach(RaycastHit hitInfo in hitInfos) {
			PlayerController player = hitInfo.collider.GetComponent<PlayerController>();
			if (player.playerEnergy < HIT_FORCE) {
				bulletOrigin.killsCount += bulletOrigin == player ? -1 : 1;
			}
			player.playerEnergy -= HIT_FORCE;
		}

		rigidbody.AddExplosionForce(5.0f,other.contacts[0].point,25.0f);
		
		DestroyObject(gameObject);
		//DestroyObject(gameObject);
	}

	// Update is called once per frame
	public override void Update () {
		base.Update();
	
	}
}
