﻿using UnityEngine;
using System.Collections;

public class SimpleBulletBehaviour : BaseBulletBehaviour {
	const int HIT_FORCE = 5;
	const float EXPLOSION_AMOUNT = -0.05f;
	public GameObject smallRockPrefab;
	public LayerMask bulletMask;

	Vector3 prevPosition;
	// Use this for initialization
	void Start () {
		prevPosition = transform.position;
		rigidbody.AddRelativeForce(50000.0f,0,0);
	}
	
	// Update is called once per frame
	void Update () {
		if (transform.position.x < -160) {
			transform.position = new Vector3(320 + transform.position.x,transform.position.y,transform.position.z);
			GetComponent<TrailRenderer>().enabled = false;
			prevPosition = transform.position;
			GetComponent<TrailRenderer>().enabled = true;
		}
		if (transform.position.x > 160) {
			transform.position = new Vector3(-320 + transform.position.x,transform.position.y,transform.position.z);
			GetComponent<TrailRenderer>().enabled = false;
			prevPosition = transform.position;
			GetComponent<TrailRenderer>().enabled = true;
		}
		if (transform.position.z < -100) {
			transform.position = new Vector3(transform.position.x,transform.position.y,200 + transform.position.z);
			GetComponent<TrailRenderer>().enabled = false;
			prevPosition = transform.position;
			GetComponent<TrailRenderer>().enabled = true;
		}
		if (transform.position.z > 100) {
			transform.position = new Vector3(transform.position.x,transform.position.y,-200 + transform.position.z);
			GetComponent<TrailRenderer>().enabled = false;
			prevPosition = transform.position;
			GetComponent<TrailRenderer>().enabled = true;
		}

		RaycastHit hitInfo;
		//Ray ray = new Ray(prevPosition,transform.position - prevPosition);
		Vector3 dir = (transform.position - prevPosition);
		if (Physics.CapsuleCast(prevPosition, transform.position,2.0f,dir.normalized,out hitInfo,dir.magnitude)) {
			if (hitInfo.collider.tag == "Terrain") {
				int x =  TerrainBehaviour.TranslateX(hitInfo.point.x);
				int y =  TerrainBehaviour.TranslateY(hitInfo.point.z);
				
				float totalAmount = TerrainBehaviour.instance.ModifyTerrain(y,x,TerrainBehaviour.instance.smallExplosion,EXPLOSION_AMOUNT);			
				GameObject obj = (GameObject)GameObject.Instantiate(smallRockPrefab);
				obj.GetComponent<RockBehaviour>().amount = totalAmount;
				obj.transform.position = hitInfo.point;
			}

			if (hitInfo.collider.tag == "Player") {
				PlayerController player = hitInfo.collider.GetComponent<PlayerController>();
				if (player.playerEnergy < HIT_FORCE) {
					bulletOrigin.killsCount += bulletOrigin == player ? -1 : 1;
				}
				player.playerEnergy -= HIT_FORCE;
			}
			rigidbody.AddExplosionForce(2.0f,hitInfo.point,5.0f);
			DestroyObject(gameObject);

		}
	
		prevPosition = transform.position;
	}
}
